widget_quintupoltrobol/assignments/urls.py
from django.urls import path

from .views import pageview, AssignmentDetailView, AssignmentCreateView, AssignmentEditView

urlpatterns = [
    path('', pageview, name='pageview'),
    path('<int:pk>/details', AssignmentDetailView.as_view(), name='assignment-details'),
    path('add', AssignmentCreateView.as_view(), name='assignment-add'),
    path('<int:pk>/edit', AssignmentEditView.as_view(), name='assignment-edit'),
]

app_name = "assignments"

widget_quintupoltrobol/forum/urls.py
from django.urls import path
from .views import pageview, ForumpostDetailView, ForumpostCreateView, ForumpostUpdateView

urlpatterns = [
    path('', pageview, name='pageview'),
    path('forumposts/<int:pk>/details/', ForumpostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add/', ForumpostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit/', ForumpostUpdateView.as_view(), name='forumpost-edit'),
]

app_name = "forum"

widget_quintupoltrobol/widget_quintupoltrobol/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('widget_calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('admin/', admin.site.urls),
]

widget_quintupoltrobol/assignments/models.py
from django.db import models
from django.urls import reverse
from django.core.validators import RegexValidator

# Create your models here.

class Course(models.Model):
    code = models.CharField(default="", max_length=10)
    title = models.CharField(default="", max_length=50)
    section = models.CharField(
        default="",max_length=3, 
        unique=True, 
        validators=[RegexValidator(r'^[a-zA-Z]*$',
        message='Only letters are allowed')])
    
    def __str__(self):
        return "%s %s - %s" % (self.code, self.title, self.section)
    
    
       
class Assignment(models.Model):
    
    name = models.CharField(default="", max_length=50)
    description = models.TextField(default="", max_length=700)
    course = models.ForeignKey(Course, on_delete=models.CASCADE)
    perfect_score = models.PositiveIntegerField(default=0)
    
    def get_absolute_url(self):
        return reverse('assignments:assignment-details', kwargs={'pk' : self.pk})
    
    def __str__(self):
        return self.name
    
    def get_passing_score(self):
        pass_score = self.perfect_score * (60/100)
        return pass_score
    
    @property
    def passing_score(self):
        return self.get_passing_score()
    
    
    

widget_quintupoltrobol/assignments/views.py
from django.shortcuts import render
from .models import Assignment, Course
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

def pageview(request):
    all_assignment = Assignment.objects.all()
    all_course = Course.objects.all()
    
    return render(request, 'assignments/assignments.html', {'assignment': all_assignment, 'course': all_course})

class AssignmentDetailView(DetailView):
    def get(self, request, pk):
        assignment = Assignment.objects.get(pk=pk)
        course = assignment.course
        
        return render(request, 'assignments/assignment-details.html', {'assignment': assignment, 'course': course})

class AssignmentCreateView(CreateView):
    model = Assignment
    fields = '__all__'
    template_name = 'assignments/assignment-add.html'

class AssignmentEditView(UpdateView):
    model = Assignment
    fields = '__all__'
    template_name = 'assignments/assignment-edit.html'
    

widget_quintupoltrobol/assignments/templates/assignments/assignment-add.html
{% extends 'base.html' %}
{% load static %}
{% block title %} Add Assignment {% endblock %}
{% block content %}
<h2>Add a new Assignment:</h2>
<p>
<form action='' method="POST">
    {% csrf_token %}
    Name: {{form.name}}<br><br>
    Description: <br> {{form.description}}<br><br>
    Course: {{form.course}}<br><br>
    Perfect Score: {{form.perfect_score}}<br><br>
    <input type="submit" value="Save New Assignment">
</form>
</p>
{% endblock %}

widget_quintupoltrobol/assignments/templates/assignments/assignment-details.html
{% extends 'base.html' %}
{% load static %}
{% block title %} {{assignment}} {% endblock %}
{% block content %}
<h2>{{assignment}}</h2>
<h3>{{assignment.course}}</h3>
<p>
    Description: {{assignment.description}}<br>
    Perfect Score: {{assignment.perfect_score}}<br>
    Passing Score: {{assignment.passing_score}}<br>
</p>

<form action='edit'>
    <input type="submit" value="Edit Assignment"/>
</form>
{% endblock %}

widget_quintupoltrobol/assignments/templates/assignments/assignment-edit.html
{% extends 'base.html' %}
{% load static %}
{% block title %} Edit Assignment {% endblock %}
{% block content %}
<h2>Edit Assignments:</h2>
<p>
<form action='' method="POST">
    {% csrf_token %}
    Name: {{form.name}}<br><br>
    Description: <br> {{form.description}}<br><br>
    Course: {{form.course}}<br><br>
    Perfect Score: {{form.perfect_score}}<br><br>
    <input type="submit" value="Save Changes to Assignment">
</form>
</p>
{% endblock %}

widget_quintupoltrobol/assignments/templates/assignments/assignments.html
{% extends 'base.html' %}
{% load static %}
{% block title %} Widget's Assignments {% endblock %}
{% block content %}
<h2> Welcome to Widget's Assignments! </h2>
{% for data in assignment %}
<p> <a href="{{ data.get_absolute_url }}">{{ data }}</a></p>
{% endfor %}
<br>
<button type="button"><a href="{% url 'assignments:assignment-add' %}"> New Assignment </a></button><br><br>
<a href="{% url 'dashboard:pageview' %}">Dashboard</a><br>
<a href="{% url 'announcements:pageview' %}">Announcements</a><br>
<a href="{% url 'forum:pageview' %}">Forum</a><br>
<a href="{% url 'widget_calendar:pageview' %}">Calendar</a><br>

{% endblock %}